﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="Default.aspx.cs" Inherits="TreeViewFiltering.Default" %>
<%@ Register tagPrefix="telerik" namespace="Telerik.Web.UI" assembly="Telerik.Web.UI" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head id="Head1" runat="server">
    <title></title>
</head>
<body>
    <form id="form1" runat="server">
	<asp:ScriptManager ID="ScriptManager1" runat="server" />
	<script type="text/javascript">

        var timer = null;
        
        function clientLoad(sender) {
            $telerik.$(".riTextBox", sender.get_element().parentNode).bind("keydown", valueChanging);
        }

		function valueChanging(sender, args) {
            if(timer)
            {
                clearTimeout(timer);
            }

            timer = setTimeout(function() {
                var tree = $find("<%= RadTreeView1.ClientID %>");
                var textbox = $find("<%= RadTextBox1.ClientID %>");
                var searchString = textbox.get_element().value;
            
                for (var i = 0; i < tree.get_nodes().get_count(); i++) {
                    findNodes(tree.get_nodes().getNode(i), searchString);
                }
            }, 200);
        }

        function findNodes(node, searchString) {
            node.set_expanded(true);

            var hasFoundChildren = false;
            for (var i = 0; i < node.get_nodes().get_count(); i++) {
                hasFoundChildren = findNodes(node.get_nodes().getNode(i), searchString) || hasFoundChildren;
            }

            if (hasFoundChildren || node.get_text().toLowerCase().indexOf(searchString.toLowerCase()) != -1) {
                node.set_visible(true);
                return true;
            }
            else {
                node.set_visible(false);
                return false;
            }
        }

    </script>
    <div>
        <telerik:RadTextBox ClientEvents-OnLoad="clientLoad" ID="RadTextBox1" runat="server"/>
        <telerik:RadTreeView ID="RadTreeView1" runat="server">
	    <ExpandAnimation Type="None" />
            <CollapseAnimation Type="None" />
        </telerik:RadTreeView>

    </div>
    </form>
</body>
</html>